package com.community.huiju.controller;

import com.aliyun.oss.OSSClient;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.ByteArrayInputStream;
import java.util.Date;

/**
 * @author weichaochao
 * @Title: ImageController
 * @Description: 图片上传以及获取url
 * @date 2018/10/31
 */
@RestController
@RefreshScope
@RequestMapping("/")
@Api(value = "图片操作API", description = "图片操作API")
public class ImageController {

    private static String imgName = System.currentTimeMillis() + ".png";
    private static String endpoint = "http://oss-cn-beijing.aliyuncs.com";
    private static String accessKeyId = "LTAIkc75dpkJw8Lb";
    private static String accessKeySecret = "v4bvXCaix6vSDTCFfwSAdqV53iFEQw";
    private static String bucketName = "yc-smart-community";

    @ApiOperation(value = "图片上传以及获取url", notes = "图片上传以及获取url")
    @ApiImplicitParams({@ApiImplicitParam(paramType = "form",dataType = "file",name = "uploadFile",value = "图片")})
    @RequestMapping(value = "/getUrl", method = RequestMethod.POST)
    public static String uploadImgAndGetUrl(@RequestParam("file") MultipartFile uploadFile) throws Exception {

        // 创建OSSClient实例
        OSSClient ossClient = new OSSClient(endpoint, accessKeyId, accessKeySecret);
        // 上传
        long time = System.currentTimeMillis();

        ossClient.putObject(bucketName, imgName, new ByteArrayInputStream(uploadFile.getBytes()));
        // 关闭client
        ossClient.shutdown();
        Date expiration = new Date(time + 3600 * 1000 * 24 * 365 * 10);
        String url = ossClient.generatePresignedUrl(bucketName, imgName, expiration).toString();
        return url;
    }
}
